package jalview.datamodel;

import java.util.ArrayList;
import java.util.List;

/**
 * stores data for each node in the hmm model
 * @author TZVanaalten
 *
 */
public class HMMNode
{
  //contains the match emissions for each symbol 
  List<Double> matchEmissions = new ArrayList<>();
  //contains the insert emissions for each symbol 
  List<Double> insertEmissions = new ArrayList<>();
  //contains the state transitions for each possible transition. These are bm, bi, bd, im, ii, dm and dd in order (0th position in
  // the array indicates the probability of a bm transition)
  List<Double> stateTransitions = new ArrayList<>();
  
  //annotations
  Integer alignmentColumn = null;
  char consensusResidue;
  char referenceAnnotation;
  char maskValue;
  char consensusStructure;
  public List<Double> getMatchEmissions()
  {
    return matchEmissions;
  }

  public void setMatchEmissions(List<Double> matchEmissionsL)
  {
    this.matchEmissions = matchEmissionsL;
  }
  public List<Double> getInsertEmissions()
  {
    return insertEmissions;
  }

  public void setInsertEmissions(List<Double> insertEmissionsL)
  {
    this.insertEmissions = insertEmissionsL;
  }
  public List<Double> getStateTransitions()
  {
    return stateTransitions;
  }

  public void setStateTransitions(List<Double> stateTransitionsL)
  {
    this.stateTransitions = stateTransitionsL;
  }

  public Integer getAlignmentColumn()
  {
    return alignmentColumn;
  }
  public void setAlignmentColumn(int alignmentColumn)
  {
    this.alignmentColumn = alignmentColumn;
  }
  public char getConsensusResidue()
  {
    return consensusResidue;
  }
  public void setConsensusResidue(char consensusResidue)
  {
    this.consensusResidue = consensusResidue;
  }
  public char getReferenceAnnotation()
  {
    return referenceAnnotation;
  }
  public void setReferenceAnnotation(char referenceAnnotation)
  {
    this.referenceAnnotation = referenceAnnotation;
  }
  public char getMaskValue()
  {
    return maskValue;
  }
  public void setMaskValue(char maskValue)
  {
    this.maskValue = maskValue;
  }
  public char getConsensusStructure()
  {
    return consensusStructure;
  }
  public void setConsensusStructure(char consensusStructure)
  {
    this.consensusStructure = consensusStructure;
  }
}
   
  
